warning 'off';

close all; clc; 
% clear; 

% delete('*.mat','*.pdf', '*.asv','*.fig','*.eps','cacciaFiori.m','cacciaFioriDeterministic.m','*_dynamic.m','*_static.m','*.txt','*.bin',...
%        '*.cod', '*.jnl','*.log','*_set_auxiliary_variables.m','cycle_irf.m','cycle_moments.m','transition.m');

addpath C:\dynare\4.4.3\matlab

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% CHOOSE OPTIONS
deterministicI      =      0;                            %% -- set to one if you want transition dynamics following deregulation
                                                                 %  -- otherwise: IRFs/second moments following a productivity shock

reformI             =      0;                            %% -- set to one if you consider a market reform
                                                                 %  -- otherwise: regulation set at euro area level

momentsI            =      0*(1-deterministicI); %% -- set to one if you want second moments (for given level of regulation);
                                                                 %  -- always zero when considering transition dynamics.
                                                                 
save options deterministicI reformI momentsI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% CHOOSE REFORM
pmrI   = 0; fcI    = 0;  ubI   = 0; % Baseline
% pmrI   = 0; fcI    = 0;  ubI   = 0; % Entry cost reform
% pmrI   = 0; fcI    = 1;  ubI   = 0; % Firing cost reform
% pmrI   = 1; fcI    = 0;  ubI   = 1; % High firing costs, low regulation
% pmrI   = 1; fcI    = 1;  ubI   = 1; %Joint


save reforms ubI fcI pmrI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% CALIBRATE THE MODEL AND GET INITIAL, RIGID STEADY STATE
calibration; 
% clear; 
load options
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if deterministicI==0 && reformI==0 
   %% BUSINES CYCLE DYNAMICS FOR BENCHMARK CALIBRATION WITH HIGH REGULATION (EITHER IRF OR SECOND MOMENTS)
    
   if momentsI==0
      dynare cycle_irf; load options
   else
      dynare cycle_moments; load options
%       second_moments;
      second_moments_ver2;
   end    
%        clear; 
       load options
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


                          
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if reformI==1 
   %% COMPUTE STEADY STATE AFTER MARKET REFORM   
   newsteady; 
%    clear; 
   load options
          
   if deterministicI==0 
      %% BUSINES CYCLE DYNAMICS AFTER DEREGULATION (EITHER IRF OR SECOND MOMENTS)
   
      if momentsI==0
         dynare cycle_irf; load options
      else
         dynare cycle_moments; load options
%         second_moments;
         second_moments_ver2;
      end    
             
   else
      %% TRANSITION DYNAMICS AFTER DEREGULATION
       dynare transition 
   end
   
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %% FOR CYCLE IRFS
load reforms; load steady; load options

%% Labour income tax
% if deterministicI==0 && pmrI==0 && fcI==0 &&  ubI==0; 
% save u_SS_transition_EU_CF u_SS 
% save epsW_EU_CF cmdata_epsW u_epsW ikdata_epsW...
% tauW_epsW gdpIncomedata_epsW wdata_epsW N_epsW iedata_epsW markup_epsW zc_epsW...
% N_epsW iedata_epsW markup_epsW m_epsW v_epsW q_epsW ub_epsW s_epsW thetaP_epsW ooption_epsW...
% m_epsW q_epsW zc_epsW v_epsW vfirm_epsW lfirm_epsW rho_epsW JD_epsW JC_epsW...
% netJC_epsW d_epsW yfirm_epsW vi_epsW ve_epsW gc_epsW surplusW_epsW...
% totsepfirm_epsW totsepagg_epsW endosepAG_epsW...
% mpl_epsW mpk_epsW e_epsW oo_epsW r_epsW kq_epsW wzc_epsW surplusF_epsW zav_epsW...
% phi_epsW wzcdata_epsW elasticity_epsW kfirm_epsW uc_epsW mplzc_epsW...
% seprate_epsW rk_epsW wageinc_epsW capinc_epsW divinc_epsW PRspend_epsW totinc_epsW...
% totspend_epsW z_epsW y_epsW re_epsW mrs_epsW multR_epsW mc_epsW rpD_epsW T_epsW

% end 

% if deterministicI==0 && pmrI==1 && fcI==1 &&  ubI==1;
% save u_SS_transition_US_CF u_SS
% save epsW_US_CF cmdata_epsW u_epsW ikdata_epsW... 
% tauW_epsW gdpIncomedata_epsW wdata_epsW N_epsW iedata_epsW markup_epsW zc_epsW...
% N_epsW iedata_epsW markup_epsW m_epsW v_epsW q_epsW ub_epsW s_epsW thetaP_epsW ooption_epsW...
% m_epsW q_epsW zc_epsW v_epsW vfirm_epsW lfirm_epsW rho_epsW JD_epsW JC_epsW...
% netJC_epsW d_epsW yfirm_epsW vi_epsW ve_epsW gc_epsW surplusW_epsW...
% totsepfirm_epsW totsepagg_epsW endosepAG_epsW...
% mpl_epsW mpk_epsW e_epsW oo_epsW r_epsW kq_epsW wzc_epsW surplusF_epsW zav_epsW...
% phi_epsW wzcdata_epsW elasticity_epsW kfirm_epsW uc_epsW mplzc_epsW...
% seprate_epsW rk_epsW wageinc_epsW capinc_epsW divinc_epsW PRspend_epsW totinc_epsW...
% totspend_epsW z_epsW y_epsW re_epsW mrs_epsW multR_epsW mc_epsW rpD_epsW T_epsW
% end
% 
% if deterministicI==0 && pmrI==0 && fcI==1 &&  ubI==0;
% save u_SS_transition_FCUS_CF u_SS
% save epsW_FCUS_CF cmdata_epsW u_epsW ikdata_epsW... 
% tauW_epsW gdpIncomedata_epsW wdata_epsW N_epsW iedata_epsW markup_epsW zc_epsW...
% N_epsW iedata_epsW markup_epsW m_epsW v_epsW q_epsW ub_epsW s_epsW thetaP_epsW ooption_epsW...
% m_epsW q_epsW zc_epsW v_epsW vfirm_epsW lfirm_epsW rho_epsW JD_epsW JC_epsW...
% netJC_epsW d_epsW yfirm_epsW vi_epsW ve_epsW gc_epsW surplusW_epsW...
% totsepfirm_epsW totsepagg_epsW endosepAG_epsW...
% mpl_epsW mpk_epsW e_epsW oo_epsW r_epsW kq_epsW wzc_epsW surplusF_epsW zav_epsW...
% phi_epsW wzcdata_epsW elasticity_epsW kfirm_epsW uc_epsW mplzc_epsW...
% seprate_epsW rk_epsW wageinc_epsW capinc_epsW divinc_epsW PRspend_epsW totinc_epsW...
% totspend_epsW z_epsW y_epsW re_epsW mrs_epsW multR_epsW mc_epsW rpD_epsW T_epsW
% end
%% Capital income tax
% if deterministicI==0 && pmrI==0 && fcI==0 &&  ubI==0; 
% save u_SS_transition_EU_CF u_SS 
% save epsK_EU_CF cmdata_epsK u_epsK ikdata_epsK...
% tauK_epsK gdpIncomedata_epsK wdata_epsK N_epsK iedata_epsK markup_epsK zc_epsK...
% N_epsK iedata_epsK markup_epsK m_epsK v_epsK q_epsK ub_epsK s_epsK thetaP_epsK ooption_epsK...
% m_epsK q_epsK zc_epsK v_epsK vfirm_epsK lfirm_epsK rho_epsK JD_epsK JC_epsK...
% netJC_epsK d_epsK yfirm_epsK vi_epsK ve_epsK gc_epsK surplusW_epsK...
% totsepfirm_epsK totsepagg_epsK endosepAG_epsK...
% mpl_epsK mpk_epsK e_epsK oo_epsK r_epsK kq_epsK wzc_epsK surplusF_epsK zav_epsK...
% phi_epsK wzcdata_epsK elasticity_epsK kfirm_epsK uc_epsK mplzc_epsK...
% seprate_epsK rk_epsK wageinc_epsK capinc_epsK divinc_epsK PRspend_epsK totinc_epsK...
% totspend_epsK z_epsK y_epsK re_epsK mrs_epsK multR_epsK mc_epsK rpD_epsK T_epsK
% end 

% if deterministicI==0 && pmrI==1 && fcI==1 &&  ubI==1;
% save u_SS_transition_US_CF u_SS
% save epsK_US_CF cmdata_epsK u_epsK ikdata_epsK... 
% tauK_epsK gdpIncomedata_epsK wdata_epsK N_epsK iedata_epsK markup_epsK zc_epsK...
% N_epsK iedata_epsK markup_epsK m_epsK v_epsK q_epsK ub_epsK s_epsK thetaP_epsK ooption_epsK...
% m_epsK q_epsK zc_epsK v_epsK vfirm_epsK lfirm_epsK rho_epsK JD_epsK JC_epsK...
% netJC_epsK d_epsK yfirm_epsK vi_epsK ve_epsK gc_epsK surplusW_epsK...
% totsepfirm_epsK totsepagg_epsK endosepAG_epsK...
% mpl_epsK mpk_epsK e_epsK oo_epsK r_epsK kq_epsK wzc_epsK surplusF_epsK zav_epsK...
% phi_epsK wzcdata_epsK elasticity_epsK kfirm_epsK uc_epsK mplzc_epsK...
% seprate_epsK rk_epsK wageinc_epsK capinc_epsK divinc_epsK PRspend_epsK totinc_epsK...
% totspend_epsK z_epsK y_epsK re_epsK mrs_epsK multR_epsK mc_epsK rpD_epsK T_epsK
% end

% if deterministicI==0 && pmrI==0 && fcI==1 &&  ubI==0;
% save u_SS_transition_FCUS_CF u_SS
% save epsK_FCUS_CF cmdata_epsK u_epsK ikdata_epsK... 
% tauK_epsK gdpIncomedata_epsK wdata_epsK N_epsK iedata_epsK markup_epsK zc_epsK...
% N_epsK iedata_epsK markup_epsK m_epsK v_epsK q_epsK ub_epsK s_epsK thetaP_epsK ooption_epsK...
% m_epsK q_epsK zc_epsK v_epsK vfirm_epsK lfirm_epsK rho_epsK JD_epsK JC_epsK...
% netJC_epsK d_epsK yfirm_epsK vi_epsK ve_epsK gc_epsK surplusW_epsK...
% totsepfirm_epsK totsepagg_epsK endosepAG_epsK...
% mpl_epsK mpk_epsK e_epsK oo_epsK r_epsK kq_epsK wzc_epsK surplusF_epsK zav_epsK...
% phi_epsK wzcdata_epsK elasticity_epsK kfirm_epsK uc_epsK mplzc_epsK...
% seprate_epsK rk_epsK wageinc_epsK capinc_epsK divinc_epsK PRspend_epsK totinc_epsK...
% totspend_epsK z_epsK y_epsK re_epsK mrs_epsK multR_epsK mc_epsK rpD_epsK T_epsK
% end

%% Government consumption shock
% if deterministicI==0 && pmrI==0 && fcI==0 &&  ubI==0; 
% save u_SS_transition_EU_CF u_SS 
% save epsG_EU_CF cmdata_epsG u_epsG ikdata_epsG...
% gdpIncomedata_epsG wdata_epsG N_epsG iedata_epsG markup_epsG zc_epsG...
% N_epsG iedata_epsG markup_epsG m_epsG v_epsG q_epsG ub_epsG s_epsG thetaP_epsG ooption_epsG...
% m_epsG q_epsG zc_epsG v_epsG vfirm_epsG lfirm_epsG rho_epsG JD_epsG JC_epsG...
% netJC_epsG d_epsG yfirm_epsG vi_epsG ve_epsG gc_epsG surplusW_epsG...
% totsepfirm_epsG totsepagg_epsG endosepAG_epsG...
% mpl_epsG mpk_epsG e_epsG oo_epsG r_epsG kq_epsG wzc_epsG surplusF_epsG zav_epsG...
% phi_epsG wzcdata_epsG elasticity_epsG kfirm_epsG uc_epsG mplzc_epsG...
% seprate_epsG rk_epsG wageinc_epsG capinc_epsG divinc_epsG PRspend_epsG totinc_epsG...
% totspend_epsG z_epsG y_epsG re_epsG mrs_epsG multR_epsG mc_epsG rpD_epsG T_epsG
% end 

% if deterministicI==0 && pmrI==1 && fcI==1 &&  ubI==1;
% save u_SS_transition_US_CF u_SS
% save epsG_US_CF cmdata_epsG u_epsG ikdata_epsG... 
% gdpIncomedata_epsG wdata_epsG N_epsG iedata_epsG markup_epsG zc_epsG...
% N_epsG iedata_epsG markup_epsG m_epsG v_epsG q_epsG ub_epsG s_epsG thetaP_epsG ooption_epsG...
% m_epsG q_epsG zc_epsG v_epsG vfirm_epsG lfirm_epsG rho_epsG JD_epsG JC_epsG...
% netJC_epsG d_epsG yfirm_epsG vi_epsG ve_epsG gc_epsG surplusW_epsG...
% totsepfirm_epsG totsepagg_epsG endosepAG_epsG...
% mpl_epsG mpk_epsG e_epsG oo_epsG r_epsG kq_epsG wzc_epsG surplusF_epsG zav_epsG...
% phi_epsG wzcdata_epsG elasticity_epsG kfirm_epsG uc_epsG mplzc_epsG...
% seprate_epsG rk_epsG wageinc_epsG capinc_epsG divinc_epsG PRspend_epsG totinc_epsG...
% totspend_epsG z_epsG y_epsG re_epsG mrs_epsG multR_epsG mc_epsG rpD_epsG T_epsG
% end

% if deterministicI==0 && pmrI==0 && fcI==1 &&  ubI==0;
% save u_SS_transition_FCUS_CF u_SS
% save epsG_FCUS_CF cmdata_epsG u_epsG ikdata_epsG... 
% gdpIncomedata_epsG wdata_epsG N_epsG iedata_epsG markup_epsG zc_epsG...
% N_epsG iedata_epsG markup_epsG m_epsG v_epsG q_epsG ub_epsG s_epsG thetaP_epsG ooption_epsG...
% m_epsG q_epsG zc_epsG v_epsG vfirm_epsG lfirm_epsG rho_epsG JD_epsG JC_epsG...
% netJC_epsG d_epsG yfirm_epsG vi_epsG ve_epsG gc_epsG surplusW_epsG...
% totsepfirm_epsG totsepagg_epsG endosepAG_epsG...
% mpl_epsG mpk_epsG e_epsG oo_epsG r_epsG kq_epsG wzc_epsG surplusF_epsG zav_epsG...
% phi_epsG wzcdata_epsG elasticity_epsG kfirm_epsG uc_epsG mplzc_epsG...
% seprate_epsG rk_epsG wageinc_epsG capinc_epsG divinc_epsG PRspend_epsG totinc_epsG...
% totspend_epsG z_epsG y_epsG re_epsG mrs_epsG multR_epsG mc_epsG rpD_epsG T_epsG
% end

%% Productivity shock
% if deterministicI==0 && pmrI==0 && fcI==0 &&  ubI==0; 
% save u_SS_transition_EU_CF u_SS
% save epsZ_EU_CF cmdata_epsZ u_epsZ ikdata_epsZ...
% gdpIncomedata_epsZ wdata_epsZ N_epsZ iedata_epsZ markup_epsZ zc_epsZ...
% N_epsZ iedata_epsZ markup_epsZ m_epsZ v_epsZ q_epsZ ub_epsZ s_epsZ thetaP_epsZ ooption_epsZ...
% m_epsZ q_epsZ zc_epsZ v_epsZ vfirm_epsZ lfirm_epsZ rho_epsZ JD_epsZ JC_epsZ...
% netJC_epsZ d_epsZ yfirm_epsZ vi_epsZ ve_epsZ gc_epsZ surplusW_epsZ...
% totsepfirm_epsZ totsepagg_epsZ endosepAG_epsZ...
% mpl_epsZ mpk_epsZ e_epsZ oo_epsZ r_epsZ kq_epsZ wzc_epsZ surplusF_epsZ zav_epsZ...
% phi_epsZ wzcdata_epsZ elasticity_epsZ kfirm_epsZ uc_epsZ mplzc_epsZ...
% seprate_epsZ rk_epsZ wageinc_epsZ capinc_epsZ divinc_epsZ PRspend_epsZ totinc_epsZ...
% totspend_epsZ z_epsZ y_epsZ re_epsZ mrs_epsZ multR_epsZ mc_epsZ rpD_epsZ T_epsZ
% end

% if deterministicI==0 && pmrI==1 && fcI==1 &&  ubI==1;
% save u_SS_transition_US_CF u_SS
% save epsZ_US_CF cmdata_epsZ u_epsZ ikdata_epsZ... 
% gdpIncomedata_epsZ wdata_epsZ N_epsZ iedata_epsZ markup_epsZ zc_epsZ...
% N_epsZ iedata_epsZ markup_epsZ m_epsZ v_epsZ q_epsZ ub_epsZ s_epsZ thetaP_epsZ ooption_epsZ...
% m_epsZ q_epsZ zc_epsZ v_epsZ vfirm_epsZ lfirm_epsZ rho_epsZ JD_epsZ JC_epsZ...
% netJC_epsZ d_epsZ yfirm_epsZ vi_epsZ ve_epsZ gc_epsZ surplusW_epsZ...
% totsepfirm_epsZ totsepagg_epsZ endosepAG_epsZ...
% mpl_epsZ mpk_epsZ e_epsZ oo_epsZ r_epsZ kq_epsZ wzc_epsZ surplusF_epsZ zav_epsZ...
% phi_epsZ wzcdata_epsZ elasticity_epsZ kfirm_epsZ uc_epsZ mplzc_epsZ...
% seprate_epsZ rk_epsZ wageinc_epsZ capinc_epsZ divinc_epsZ PRspend_epsZ totinc_epsZ...
% totspend_epsZ z_epsZ y_epsZ re_epsZ mrs_epsZ multR_epsZ mc_epsZ rpD_epsZ T_epsZ
% end

% if deterministicI==0 && pmrI==0 && fcI==1 &&  ubI==0;
% save u_SS_transition_FCUS_CF u_SS
% save epsZ_FCUS_CF cmdata_epsZ u_epsZ ikdata_epsZ... 
% gdpIncomedata_epsZ wdata_epsZ N_epsZ iedata_epsZ markup_epsZ zc_epsZ...
% N_epsZ iedata_epsZ markup_epsZ m_epsZ v_epsZ q_epsZ ub_epsZ s_epsZ thetaP_epsZ ooption_epsZ...
% m_epsZ q_epsZ zc_epsZ v_epsZ vfirm_epsZ lfirm_epsZ rho_epsZ JD_epsZ JC_epsZ...
% netJC_epsZ d_epsZ yfirm_epsZ vi_epsZ ve_epsZ gc_epsZ surplusW_epsZ...
% totsepfirm_epsZ totsepagg_epsZ endosepAG_epsZ...
% mpl_epsZ mpk_epsZ e_epsZ oo_epsZ r_epsZ kq_epsZ wzc_epsZ surplusF_epsZ zav_epsZ...
% phi_epsZ wzcdata_epsZ elasticity_epsZ kfirm_epsZ uc_epsZ mplzc_epsZ...
% seprate_epsZ rk_epsZ wageinc_epsZ capinc_epsZ divinc_epsZ PRspend_epsZ totinc_epsZ...
% totspend_epsZ z_epsZ y_epsZ re_epsZ mrs_epsZ multR_epsZ mc_epsZ rpD_epsZ T_epsZ
% end